## simgrid 3.21+dfsg

=== docs/requirements.txt ===
breathe
javasphinx
sphinx>=1.8.0
sphinx_rtd_theme
