=== debian/changelog ===
simgrid (3.21+dfsg-4) unstable; urgency=medium

  * d/p/reproducible-build: make builds reproducible (from upstream).
  * Mark simgrid-doc as Multi-Arch: foreign.
  * Use the right path to the Perl interpreter in scripts to please
    lintian.

 -- Martin Quinson <mquinson@debian.org>  Thu, 22 Nov 2018 08:01:56 +0100

simgrid (3.21+dfsg-3) unstable; urgency=medium

  * Another attempt at fixing kFreeBSD, cherry-picking upstream patches.

 -- Martin Quinson <mquinson@debian.org>  Sun, 21 Oct 2018 22:55:04 +0200

simgrid (3.21+dfsg-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces
  * d/control: Remove trailing whitespaces

  [ Martin Quinson ]
  * Add a new patch to fix a FTBFS on FreeBSD 32bits.
  * d/control: bump standard-version to 4.2.0 (no other change required)

 -- Martin Quinson <mquinson@debian.org>  Mon, 15 Oct 2018 22:51:45 +0200

simgrid (3.21+dfsg-1) unstable; urgency=medium

  * New upstream release (3.19: Moscovitly-cold Spring release):
    * SMPI: Allow one to start new actors and ranks after simulation start.
    * SMPI: Support ICC, better testing on classical proxy apps.
    * Some kernel headers are now installed, allowing external plugins.
    * (+ the classical bug fixes and doc improvement)
  * New upstream release (3.20: The proxy snake_case() release):
    * Sanitize the public API. Compatibility wrappers in place for one year.
    * More CI: ~45 Proxy Apps + BigDFT + StarPU now tested nightly
    * MPI: Port the trace replay engine to C++, fix visualization
    * (+ the classical bug fixes and doc improvement)
  * New upstream release (3.21: Restarting Documentation release):
    * Start to overhaul the documentation, and move to Sphinx + RTD.
    * Allow dynamic replay of MPI apps, controlled by S4U actors
    * Rewrite the support for auto-restarted actors (was utterly broken)
    * (+ the classical bug fixes and doc improvement)
  * Move smpimain from libsimgrid3.XX to libsimgrid-dev to allow to
    install more than one version of the versioned lib package.
  * Restore the build-dep on NS3 now that this package is fixed.
  * d/copyright align with upstream COPYING; add a Files-Excluded stanza
  * d/watch: now, uscan can properly repack and remove unfree stuff
  * d/rules: kill the get-orig-source taget to please lintian
  * d/control:
    - Point Vcs-* fields to salsa.debian.org
    - Bump standard version to 4.1.5 (get-orig-source target is gone)
  * Use system-wide versions of jquery and jquery-ui in javadoc.

 -- Martin Quinson <mquinson@debian.org>  Fri, 05 Oct 2018 22:22:24 +0200
