=== debian/control ===
Source: simgrid
Section: science
Priority: optional
Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders: Lucas Nussbaum <lucas@debian.org>
Build-Depends:
 debhelper (>= 9),
 cmake,
 chrpath,
 default-jdk (>= 2:1.7~),
 dh-python,
 doxygen,
 valgrind [amd64 armhf i386 mips mipsel mips64 mips64el powerpc ppc64 s390x x32],
 gfortran,
 liblua5.3-dev, lua5.3,
# Disabled for now: libboost-context-dev. Seems broken on amd64
 libboost-dev,
 libns3-dev,
# Needed to build the doc
 transfig, ghostscript, libjs-mathjax,
 python3,
Standards-Version: 4.2.1
Homepage: http://simgrid.org/
Vcs-Git: https://salsa.debian.org/debian/simgrid.git
Vcs-Browser: https://salsa.debian.org/debian/simgrid

Package: libsimgrid3.21
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: lua5.1
Breaks: simgrid (<< 3.11)
Replaces: simgrid (<< 3.11)
Description: Toolkit for scalable simulation of distributed applications
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains the dynamic libraries and runtime.

Package: simgrid-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-jquery-ui,
  libjs-mathjax,
Breaks: simgrid (<< 3.11)
Replaces: simgrid (<< 3.11)
Description: Documentation for the SimGrid Toolkit
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains the documentation for both the C and the Java
 version of SimGrid.

Package: simgrid-java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libsimgrid3.21 (>= ${source:Version})
Recommends: simgrid-doc (>= ${source:Version})
Breaks: simgrid (<< 3.11)
Replaces: simgrid (<< 3.11)
Suggests: java-virtual-machine
Description: Java bindings for the SimGrid Toolkit
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains what you need to use SimGrid from the Java
 programming language.

Package: libsimgrid-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${python3:Depends},
  libsimgrid3.21 (= ${binary:Version}),
  simgrid-java (= ${binary:Version}),
Recommends: gcc, make, simgrid-doc (>= ${source:Version})
Conflicts: simgrid
Replaces: simgrid
Provides: simgrid
Description: Development files for the SimGrid Toolkit
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains the development files that you need to build
 your own simulator on top of SimGrid (header files and helping scripts).
